import 'package:hmg_patient_app_new/core/api/api_client.dart';
import 'package:hmg_patient_app_new/core/api_consts.dart';
import 'package:hmg_patient_app_new/core/exceptions/api_failure.dart';
import 'package:hmg_patient_app_new/core/common_models/generic_api_model.dart';
import 'package:dartz/dartz.dart';
import 'package:hmg_patient_app_new/features/lab/models/resp_models/patient_lab_orders_response_model.dart';
import 'package:hmg_patient_app_new/services/logger_service.dart';

abstract class LabRepo {
  Future<Either<Failure, GenericApiModel<List<PatientLabOrdersResponseModel>>>> getPatientLabOrders({required String patientId});
}

class LabRepoImp implements LabRepo {
  final ApiClient apiClient;
  final LoggerService loggerService;

  LabRepoImp({required this.loggerService, required this.apiClient});

  @override
  Future<Either<Failure, GenericApiModel<List<PatientLabOrdersResponseModel>>>> getPatientLabOrders({required String patientId}) async {
    final mapDevice = {
      "isDentalAllowedBackend": false,
      "VersionID": 50.0,
      "Channel": 3,
      "LanguageID": 2,
      "IPAdress": "10.20.10.20",
      "generalid": "Cs2020@2016\$2958",
      "Latitude": 0.0,
      "Longitude": 0.0,
      "DeviceTypeID": 1,
      "PatientType": 1,
      "PatientTypeID": 1,
      "TokenID": "@dm!n",
      "PatientID": "1018977",
      "PatientOutSA": "0",
      "SessionID": "03478TYC02N80874CTYN04883475!?"
    };

    try {
      GenericApiModel<List<PatientLabOrdersResponseModel>>? apiResponse;
      Failure? failure;
      await apiClient.post(
        GET_Patient_LAB_ORDERS,
        body: mapDevice,
        onFailure: (error, statusCode, {messageStatus, failureType}) {
          failure = failureType;
        },
        onSuccess: (response, statusCode, {messageStatus, errorMessage}) {
          try {
            final list = response['ListPLO'];
            if (list == null || list.isEmpty) {
              throw Exception("lab list is empty");
            }

            final labOrders = list
                .map((item) => PatientLabOrdersResponseModel.fromJson(item as Map<String, dynamic>))
                .toList()
                .cast<PatientLabOrdersResponseModel>();

            apiResponse = GenericApiModel<List<PatientLabOrdersResponseModel>>(
              messageStatus: messageStatus,
              statusCode: statusCode,
              errorMessage: null,
              data: labOrders,
            );
          } catch (e) {
            failure = DataParsingFailure(e.toString());
          }
        },
      );
      if (failure != null) return Left(failure!);
      if (apiResponse == null) return Left(ServerFailure("Unknown error"));
      return Right(apiResponse!);
    } catch (e) {
      return Left(UnknownFailure(e.toString()));
    }
  }
}
